---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by brode.
--- DateTime: 01.07.2021 15:55
---
local AddonName, BohemkaDKP = ...
BohemkaDKP.frames = {}
BIDDER_TABLE_SIZE = 7
PROFESSION_AMOUNT = 6

GUILD_FRAME_COLUMN_WIDTH_DKP = 60
GUILD_FRAME_COLUMN_WIDTH_PROFESSIONS = 101
GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_NOTE = 74.5
GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_ONLINE = 49
GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_ONLINE_NO_SCROLL = 40
CLASS_COLUMN_WIDTH = 87.5
FRIENDS_FRAME_WIDTH = FriendsFrame:GetWidth() + GUILD_FRAME_COLUMN_WIDTH_DKP + GUILD_FRAME_COLUMN_WIDTH_PROFESSIONS

FRIENDS_FRAME_TAB_COUNT = 5
LAST_COLUMN_HEADER_INDEX = 4
LAST_COLUMN_STATUS_HEADER_INDEX = 2
LAST_COLUMN_HEADER_NAME = "Class"
SHOW_OFFLINE_MEMBERS = "Offline Members"

BohemkaDKP.editModeButtons = {
    "SelectAllDKP",
    "ButtonSubtractAll",
    "ButtonAddAll"
}

function BohemkaDKP:AdjustUI()
    self:CreateGuildFrameProfessionsColumnHeader()

    self:CreateGuildFrameGuildStatusNoteColumnHeader()
    self:ReplaceGuildFrameGuildStatusNoteHeaderWithDKP()
    self:CreateGuildFrameEditModeButtons()
    GuildFrameLFGButtonText:SetText(SHOW_OFFLINE_MEMBERS)

    for i=1, GUILDMEMBERS_TO_DISPLAY do
        local _, _, _, _, _, _, _, officerNote, _, _ = GetGuildRosterInfo(i)
        self:CreateGuildFrameGuildStatusNote(i, officerNote)
        local profContainer = CreateFrame("Frame", "GuildFrameProfContainer"..i, GuildFrame)
        self:CreateGuildFrameProfessionButton("GuildFrameProf"..i, 15, profContainer, "LEFT", _G["GuildFrameButton"..i..LAST_COLUMN_HEADER_NAME], "RIGHT", -6, 0)
        if not BohemkaDKPConfig.showProfessions then
            profContainer:Hide()
        end

        self:CreateDKPCheckButton(i)
        self:FixGuildStatusOnlineButton(i)
        self:ReplaceGuildFrameGuildStatusNoteWithDKP(i, GUILD_FRAME_COLUMN_WIDTH_DKP - 20)
        if not BohemkaDKPConfig.showDKP then
            _G["GuildFrameGuildStatusButton"..i.."Note"]:Hide()
        end
        self:FixGuildFrameClassButton(i)

    end
    WhoFrameColumn_SetWidth(GuildFrameColumnHeader4, CLASS_COLUMN_WIDTH)

    GuildFrameLFGFrame:SetWidth(270)
    GuildFrameLFGFrameMiddle:SetWidth(246)
    GuildFrameLFGFrame:ClearAllPoints(true)
    GuildFrameLFGFrame:SetPoint("TOPLEFT", 60, -25)
    GuildFrameLFGButton:ClearAllPoints(true)
    GuildFrameLFGButton:SetPoint("TOPLEFT", "GuildFrameLFGFrame", 102, -2)
    GuildFrameLFGButtonText:SetPoint("RIGHT", "GuildFrameLFGButton", "LEFT", -3, 1)


    local profButton = CreateFrame("CheckButton", "GuildFrameProfButton", GuildFrameLFGFrame, "UICheckButtonTemplate")
    profButton:SetPoint("LEFT", "GuildFrameLFGButton", "RIGHT", 70, 0)
    profButton:SetSize(20, 20)
    profButton:SetChecked(BohemkaDKPConfig.showProfessions)
    profButton:SetScript("OnClick", function(self)
        BohemkaDKPConfig.showProfessions = self:GetChecked()
        BohemkaDKP:RenderColumns()
    end)

    local font = profButton:CreateFontString("$parentText","ARTWORK", "GameFontHighlightSmall")
    font:SetText("Professions")
    font:SetPoint("RIGHT", profButton, "LEFT", -3, 1)


    local dkpButton = CreateFrame("CheckButton", "GuildFrameDKPToggle", GuildFrameLFGFrame, "UICheckButtonTemplate")
    dkpButton:SetPoint("LEFT", "GuildFrameProfButton", "RIGHT", 30, 0)
    dkpButton:SetSize(20, 20)
    dkpButton:SetChecked(BohemkaDKPConfig.showDKP)
    dkpButton:SetScript("OnClick", function(self)
        BohemkaDKPConfig.showDKP =  self:GetChecked()
        BohemkaDKP:RenderColumns()
    end)

    font = dkpButton:CreateFontString("$parentText","ARTWORK", "GameFontHighlightSmall")
    font:SetText("DKP")
    font:SetPoint("RIGHT", dkpButton, "LEFT", -3, 1)

    self:CreateGuildFrameDKPButton()
    self:AdjustDetailFrame()
    self:AdjustRaidFrame()
    self:RenderColumns()
    self:OnUiAdjustedCompatibilityCallback()
end
function BohemkaDKP:UpdateCompatibility()
    if self.isElvUI then
        LAST_COLUMN_HEADER_INDEX = 2
        LAST_COLUMN_STATUS_HEADER_INDEX = 4
        LAST_COLUMN_HEADER_NAME = "Zone"
        CLASS_COLUMN_WIDTH = CLASS_COLUMN_WIDTH + 45
        GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_ONLINE = 80
        GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_ONLINE_NO_SCROLL = 78
        self.OnUpdateCompatibilityCallback = function()
            WhoFrameColumn_SetWidth(GuildFrameColumnHeader1, 92)
            WhoFrameColumn_SetWidth(GuildFrameColumnHeader2, GuildFrameColumnHeader2:GetWidth() + 30)
            WhoFrameColumn_SetWidth(GuildFrameGuildStatusColumnHeader4, GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_ONLINE_NO_SCROLL)
            for i=1, GUILDMEMBERS_TO_DISPLAY, 1 do
                local btn = getglobal("GuildFrameButton"..i..LAST_COLUMN_HEADER_NAME)
                btn:SetWidth(CLASS_COLUMN_WIDTH)
            end
            GuildFrameLFGButton:ClearAllPoints(true)
            GuildFrameLFGButton:SetPoint("TOPLEFT", "GuildFrameLFGFrame", 100, -2)
            GuildFrameLFGFrame:ClearAllPoints(true)
            GuildFrameLFGFrame:SetPoint("TOPLEFT", 1, -25)
        end
        self.OnUiAdjustedCompatibilityCallback = function()
            for _, v in ipairs({ButtonAdd, ButtonSubtract, ButtonAddAll,
                                ButtonSubtractAll, ButtonAwardRaidDKP, SelectAllDKP,
                                GuildFrameDKPButton, BohemkaDKPInterfaceOptionsPanelImport, BohemkaDKPImportFrameImport
            }) do
                v:StripTextures()
                v:StyleButton()
                ElvUI[1].Skins:HandleButton(v)
            end
            for _, v in ipairs({GuildFrameGuildStatusColumnHeader5, GuildFrameColumnHeader6}) do
                v:StripTextures()
                v:StyleButton()
            end
            local checkButtons = {
                GuildFrameProfButton, GuildFrameDKPToggle
            }
            for i=1, GUILDMEMBERS_TO_DISPLAY, 1 do
                table.insert(checkButtons, _G["GuildFrameDKPSelectButton"..i])
            end
            for _, btn in ipairs(checkButtons) do
                btn:StripTextures()
                btn:StyleButton()
                ElvUI[1].Skins:HandleCheckBox(btn)
            end
        end
    end
end
function BohemkaDKP:ReplaceGuildFrameGuildStatusNoteHeaderWithDKP()
    local noteBtn = _G["GuildFrameGuildStatusColumnHeader3"]
    noteBtn:SetParent(GuildFrame)
    noteBtn:SetText("DKP")
    noteBtn:SetPoint("LEFT", "GuildFrameColumnHeader6", "RIGHT", -2, 0)
    WhoFrameColumn_SetWidth(noteBtn, GUILD_FRAME_COLUMN_WIDTH_DKP)
end
function BohemkaDKP:CreateGuildFrameGuildStatusNote(index, value)
    local font = _G["GuildFrameGuildStatusButton"..index]:CreateFontString("GuildFrameGuildStatusButton"..index.."OfficerNote","ARTWORK", "GameFontHighlightSmall")
    font:SetJustifyH("LEFT")
    font:SetText(value)
    font:SetSize(GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_NOTE, 14)
    font:SetPoint("LEFT", "GuildFrameGuildStatusButton"..index.."Rank", "RIGHT", 11, 0)
end
function BohemkaDKP:AdjustGuildFrameButtonWidth(index, width)
    for _, button in ipairs({_G["GuildFrameGuildStatusButton"..index], _G["GuildFrameButton"..index]}) do
        button:SetWidth(width)
        local highlightTexture = button:GetHighlightTexture()
        highlightTexture:SetWidth(width)
    end
end
function BohemkaDKP:ReplaceGuildFrameGuildStatusNoteWithDKP(index, width)
    local noteButton = _G["GuildFrameGuildStatusButton"..index.."Note"]
    noteButton:SetParent(GuildFrame)
    noteButton:SetJustifyH("RIGHT")
    noteButton:SetWidth(width)
    noteButton:SetPoint("LEFT", "GuildFrameProf"..index.."Frame"..PROFESSION_AMOUNT, "RIGHT", -2, 0)
end
function BohemkaDKP:CreateDKPCheckButton(index)
    local dkpCheckButton = CreateFrame("CheckButton", "GuildFrameDKPSelectButton"..index, GuildFrame, "UICheckButtonTemplate");
    dkpCheckButton:SetPoint("LEFT", "GuildFrameGuildStatusButton"..index.."Note", "RIGHT", 2, 0)
    dkpCheckButton:SetFrameStrata("HIGH")
    dkpCheckButton:Hide()
    dkpCheckButton:SetSize(18,18)
    dkpCheckButton:SetScript("OnClick", function(self)
        local guildOffset = FauxScrollFrame_GetOffset(GuildListScrollFrame)
        local guildIndex = guildOffset + index
        local isChecked = self:GetChecked()
        local fullName = GetGuildRosterInfo(guildIndex)
        BohemkaDKP.editModeSelected[fullName] = isChecked
    end)
end
function BohemkaDKP:FixGuildStatusOnlineButton(index)
    local onlineButton = _G["GuildFrameGuildStatusButton"..index.."Online"]
    onlineButton:SetWidth(GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_ONLINE)
    onlineButton:SetPoint("LEFT", "GuildFrameGuildStatusButton"..index.."OfficerNote", "RIGHT", 10, 0)
end
function BohemkaDKP:FixGuildFrameClassButton(index)
    local classButton = _G["GuildFrameButton"..index..LAST_COLUMN_HEADER_NAME]
    classButton:SetWidth(CLASS_COLUMN_WIDTH)
    _G["GuildFrameButton"..index..LAST_COLUMN_HEADER_NAME]:SetText("AAAAAAAAAAAAAAAAAAAAAAAAAAAA")
end
function BohemkaDKP:AdjustRaidFrame()
    local awardRaid = CreateFrame("Button", "ButtonAwardRaidDKP", RaidFrame, "UIPanelButtonTemplate")
    awardRaid:SetPoint("TOPRIGHT", RaidFrame, "TOPRIGHT", -25, -1)
    awardRaid:SetSize(90, 19)
    awardRaid:SetText("Award DKP")
    awardRaid:SetNormalFontObject("GameFontNormalSmall")
    awardRaid:SetHighlightFontObject("GameFontHighlightSmall")
    awardRaid:SetDisabledFontObject("GameFontDisableSmall")
    awardRaid:RegisterForClicks("AnyUp")
    awardRaid:SetScript("OnClick", function()
        StaticPopup_Show("AWARD_GUILDPLAYERDKP_RAID")
    end)

    if not IsInRaid() then
        awardRaid:Hide()
    end
end
function BohemkaDKP:AdjustDetailFrame()
    local detailNoteLabel = _G["GuildMemberDetailNoteLabel"]
    local detailFrame = _G["GuildMemberDetailFrame"]
    detailNoteLabel:SetText("DKP:")

    f = CreateFrame("Frame", "DetailFrameDKPFrame", detailFrame);
    f:SetPoint("LEFT", "GuildFrameGuildStatusColumnHeader2", "RIGHT", -2, 0)
    f:SetSize(60, 14)
    f:SetPoint("LEFT", detailNoteLabel, "RIGHT", 2, 0)
    f:SetScript("OnMouseUp", function()
        if CanEditPublicNote() then
            StaticPopup_Show("SET_GUILDPLAYERDKP")
        end
    end)
    font = f:CreateFontString("GuildMemberDetailFrameDKP","ARTWORK", "GameFontHighlightLeft")
    font:SetWidth(60)
    font:SetPoint("LEFT")

    detailNoteLabel.dkp = font
    _G["GuildMemberDetailOfficerNoteLabel"]:SetText(NOTE_COLON)
    _G["GuildMemberDetailOfficerNoteLabel"]:SetPoint("TOPLEFT", detailNoteLabel, "BOTTOMLEFT", 0, -8)
    _G["GuildMemberNoteBackground"]:Hide()

    self:CreateGuildFrameProfessionButton("DetailFrameProf", 30, _G["GuildMemberOfficerNoteBackground"], "TOPLEFT", "GuildMemberOfficerNoteBackground", "BOTTOMLEFT", 1, -5)

    local subtract = CreateFrame("Button", "ButtonSubtract", f, "UIPanelButtonTemplate")
    subtract:SetPoint("LEFT", f, "RIGHT", 35, 0)
    subtract:SetSize(30, 20)
    subtract:SetText("-")
    subtract:RegisterForClicks("AnyUp")
    subtract:SetScript("OnClick", function()
        StaticPopup_Show("SUBTRACT_GUILDPLAYERDKP")
    end)
    subtract:Hide()
    local add = CreateFrame("Button", "ButtonAdd", f, "UIPanelButtonTemplate")
    add:SetPoint("LEFT", subtract, "RIGHT", 0, 0)
    add:SetSize(30, 20)
    add:SetText("+")
    add:RegisterForClicks("AnyUp")
    add:SetScript("OnClick", function()
        StaticPopup_Show("ADD_GUILDPLAYERDKP")
    end)
    add:Hide()

    f.subtract = subtract
    f.add = add
end
function BohemkaDKP:CreateGuildFrameDKPButton()
    f = CreateFrame("BUTTON", "GuildFrameDKPButton", GuildFrame, "UIPanelButtonTemplate");
    f:SetPoint("LEFT", "GuildFrameControlButton", "RIGHT", 0, 0)
    f:SetText("DKP")
    if not CanEditPublicNote() then
        f:Disable()
    end
    f:SetScript("OnClick", function()
        BohemkaDKP.isEditMode = not BohemkaDKP.isEditMode
        BohemkaDKP:FixToggleButton()
        BohemkaDKP:RenderColumns()
    end)
    f:SetWidth(65)
    GuildFrameGuildInformationButton:ClearAllPoints(true)
    GuildFrameAddMemberButton:ClearAllPoints(true)
    GuildFrameControlButton:ClearAllPoints(true)
    GuildFrameGuildInformationButton:SetPoint("BOTTOMLEFT", "GuildFrame", 4, 4)
    GuildFrameAddMemberButton:SetPoint("LEFT", "GuildFrameGuildInformationButton", "RIGHT", 0, 0)
    GuildFrameControlButton:SetPoint("LEFT", "GuildFrameAddMemberButton", "RIGHT", 0, 0)
end
function BohemkaDKP:ShowEditModeButtons()
    for _, button in ipairs(self.editModeButtons) do
        _G[button]:Show()
    end
end
function BohemkaDKP:HideEditModeButtons()
    for _, button in ipairs(self.editModeButtons) do
        _G[button]:Hide()
    end
end
function BohemkaDKP:CreateGuildFrameProfessionButton(prefixName, size, relativeTo, ...)
    local prevProf
    for j = 1, PROFESSION_AMOUNT do
        local profFrame = CreateFrame("Frame", prefixName.."Frame"..j, relativeTo)
        profFrame:SetSize(size, size)
        profFrame:SetFrameStrata("HIGH")
        profFrame:SetScript("OnEnter", function(self)
            if self.tooltip then
                GameTooltip:SetOwner(self, "ANCHOR_TOP");
                GameTooltip:SetText(self.tooltip);
                GameTooltip:Show();
            end
        end)
        profFrame:SetScript("OnLeave", function()
            GameTooltip:Hide();
        end)
        if not prevProf then
            profFrame:SetPoint(...)
        else
            profFrame:SetPoint("LEFT", prevProf, "RIGHT", 0, 0)
        end

        font = profFrame:CreateFontString(prefixName.."Skill"..j,"OVERLAY", "GameFontNormalSmall")
        font:SetJustifyH("CENTER")
        font:SetAllPoints(profFrame)
        font:SetText("")
        font:SetFont("Fonts\\FRIZQT__.TTF", 11, "OUTLINE")

        local prof = profFrame:CreateTexture("$parentProf", "ARTWORK")
        prof:SetAllPoints(profFrame)
        prof.parent = profFrame
        profFrame.font = font
        prevProf = profFrame
    end
end
function BohemkaDKP:CreateGuildFrameEditModeButtons()
    local buttonsWidth = 30
    local subtract = CreateFrame("Button", "ButtonSubtractAll", GuildFrame, "UIPanelButtonTemplate")
    subtract:SetPoint("LEFT", GuildFrameGuildListToggleButton, "RIGHT", 2, 0)
    subtract:SetWidth(buttonsWidth)
    subtract:SetText("-")
    subtract:RegisterForClicks("AnyUp")
    subtract:SetScript("OnClick", function()
        StaticPopup_Show("SUBTRACT_GUILDPLAYERDKP_MANY")
    end)
    subtract:Hide()

    local add = CreateFrame("Button", "ButtonAddAll", GuildFrame, "UIPanelButtonTemplate")
    add:SetPoint("LEFT", subtract, "RIGHT", 0, 0)
    add:SetWidth(buttonsWidth)
    add:SetText("+")
    add:RegisterForClicks("AnyUp")
    add:SetScript("OnClick", function()
        StaticPopup_Show("ADD_GUILDPLAYERDKP_MANY")
    end)
    add:Hide()

    f = CreateFrame("BUTTON", "SelectAllDKP", GuildFrame, "UIPanelButtonTemplate");
    f:SetText("Select All")
    f:SetWidth(80)
    f:Hide()
    f:SetPoint("LEFT", add, "RIGHT", 2, 0)
    f:SetScript("OnClick", function()
        BohemkaDKP.isSelectedAll = not BohemkaDKP.isSelectedAll
        BohemkaDKP:UpdateSelectedMembers()
    end)

end
function BohemkaDKP:UpdateSelectedMembers()
    local numMembers = BohemkaDKP:GetNumVisibleGuildMembers()
    for i=1, GetNumGuildMembers() do
        local fullName = GetGuildRosterInfo(i)
        if i <= numMembers then
            BohemkaDKP:SelectGuildMember(i, fullName, BohemkaDKP.isSelectedAll)
        else
            BohemkaDKP:SelectGuildMember(i, fullName, false)
        end

    end
end
function BohemkaDKP:SelectGuildMember(index, fullName, state)
    if index <= GUILDMEMBERS_TO_DISPLAY then
        _G["GuildFrameDKPSelectButton"..index]:SetChecked(state)
    end
    BohemkaDKP.editModeSelected[fullName] = state
end
function BohemkaDKP:CreateGuildFrameProfessionsColumnHeader()
    local f = CreateFrame("BUTTON", "GuildFrameColumnHeader6", GuildFrame, "GuildFrameColumnHeaderTemplate");
    f:SetPoint("LEFT", "GuildFrameColumnHeader"..LAST_COLUMN_HEADER_INDEX, "RIGHT", -2, 0)
    f:SetText("Professions")
    f:Disable()
    WhoFrameColumn_SetWidth(GuildFrameColumnHeader6, GUILD_FRAME_COLUMN_WIDTH_PROFESSIONS)
end
function BohemkaDKP:CreateGuildFrameGuildStatusNoteColumnHeader()
    local f = CreateFrame("BUTTON", "GuildFrameGuildStatusColumnHeader5", GuildStatusFrame, "GuildFrameColumnHeaderTemplate");
    f:SetPoint("LEFT", "GuildFrameGuildStatusColumnHeader2", "RIGHT", -2, 0)
    f:SetText("Note")
    f:Disable()
    WhoFrameColumn_SetWidth(f, GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_NOTE)
    _G["GuildFrameGuildStatusColumnHeader4"]:SetPoint("LEFT", "GuildFrameGuildStatusColumnHeader5", "RIGHT", -2, 0)
end
function BohemkaDKP:AdjustGuildFramesAfterUpdate()
    self:OnUpdateCompatibilityCallback()
    self:RenderColumns()
    self:UpdateSelectedMembers()

    WhoFrameColumn_SetWidth(GuildFrameGuildStatusColumnHeader3, GUILD_FRAME_COLUMN_WIDTH_DKP)

    local guildOffset = FauxScrollFrame_GetOffset(GuildListScrollFrame);

    local numMembers = self:GetNumVisibleGuildMembers()
    for i=1, GUILDMEMBERS_TO_DISPLAY, 1 do
        local guildIndex = guildOffset + i;
        local fullName, _, _, _, _, _, note, officerNote, online, _, classFileName = GetGuildRosterInfo(guildIndex);
        _G["GuildFrameDKPSelectButton"..i]:SetChecked(self.editModeSelected[fullName])
        if i <= numMembers then
            _G["GuildFrameGuildStatusButton"..i.."OfficerNote"]:SetText(officerNote)
            _G["GuildFrameGuildStatusButton"..i.."Note"]:SetText(self:NoteDKPToNumber(note))

            if online then
                if classFileName then
                    local color = RAID_CLASS_COLORS[classFileName]
                    _G["GuildFrameButton"..i.."Class"]:SetTextColor(color.r, color.g, color.b)
                end
            end
            self:RenderProfessions("GuildFrameProf"..i.."Frame%dProf", self:GetPlayerProfessions(fullName))
        else
            _G["GuildFrameGuildStatusButton"..i.."OfficerNote"]:SetText("")
            _G["GuildFrameGuildStatusButton"..i.."Note"]:SetText("")
        end


        _G["GuildFrameGuildStatusButton"..i.."Note"]:SetWidth(GUILD_FRAME_COLUMN_WIDTH_DKP)

        if FriendsFrame.playerStatusFrame then
            _G["GuildFrameProfContainer"..i]:SetPoint( "LEFT", _G["GuildFrameButton"..i..LAST_COLUMN_HEADER_NAME], "RIGHT", -6, 0)
        else
            _G["GuildFrameProfContainer"..i]:SetPoint( "LEFT", _G["GuildFrameGuildStatusButton"..i.."Online"], "RIGHT", -6, 0)
        end
    end
    if FriendsFrame.playerStatusFrame then
        GuildFrameColumnHeader6:SetPoint("LEFT", "GuildFrameColumnHeader"..LAST_COLUMN_HEADER_INDEX, "RIGHT", -2, 0)
    else
        GuildFrameColumnHeader6:SetPoint("LEFT", "GuildFrameGuildStatusColumnHeader4", "RIGHT", -2, 0)
    end
end
function BohemkaDKP:RenderColumns()
    local relativeTo, relativeToCol
    local width = self:GetFriendsFrameWidth()  - 40
    if BohemkaDKPConfig.showProfessions then
        GuildFrameColumnHeader6:Show()
        relativeTo = GuildFrameColumnHeader6
    else
        GuildFrameColumnHeader6:Hide()
        relativeTo = _G["GuildFrameColumnHeader"..LAST_COLUMN_HEADER_INDEX]
    end

    if BohemkaDKPConfig.showDKP then
        GuildFrameGuildStatusColumnHeader3:Show()
        GuildFrameDKPButton:Show()
    else
        GuildFrameGuildStatusColumnHeader3:Hide()
        GuildFrameDKPButton:Hide()
    end

    if self.isEditMode and BohemkaDKPConfig.showDKP then
        self:ShowEditModeButtons()
    else
        self:HideEditModeButtons()
    end

    GuildFrameGuildStatusColumnHeader3:SetPoint("LEFT", relativeTo, "RIGHT", -2, 0)
    local numMembers = self:GetNumVisibleGuildMembers()
    for i=1, GUILDMEMBERS_TO_DISPLAY, 1 do
        local prof = _G["GuildFrameProfContainer"..i]
        local dkp = _G["GuildFrameGuildStatusButton"..i.."Note"]

        local pointX
        local dkpCheckButton = _G["GuildFrameDKPSelectButton"..i]
        if self.isEditMode and BohemkaDKPConfig.showDKP then
            pointX = -12
            dkpCheckButton:SetPoint("LEFT", "GuildFrameGuildStatusButton"..i.."Note", "RIGHT", 2, 0)
            if i <= numMembers then
                dkpCheckButton:Show()
            else
                dkpCheckButton:Hide()
            end
        else
            pointX = 0
            dkpCheckButton:Hide()
        end

        if BohemkaDKPConfig.showProfessions then
            prof:Show()
            relativeToCol = _G["GuildFrameProf"..i.."Frame"..PROFESSION_AMOUNT]
            dkp:SetPoint("LEFT", relativeToCol, "RIGHT", -2 + pointX, 0)
        else
            prof:Hide()
            relativeToCol = _G["GuildFrameButton"..i..LAST_COLUMN_HEADER_NAME]
            dkp:SetPoint("LEFT", relativeToCol, "RIGHT", -14 + pointX, 0)
        end
        if BohemkaDKPConfig.showDKP then
            dkp:Show()
        else
            dkp:Hide()
        end

        self:AdjustGuildFrameButtonWidth(i, width)
    end
    local tabIndex = PanelTemplates_GetSelectedTab(FriendsFrame)
    if tabIndex == 3 then
        FriendsFrame:SetWidth(BohemkaDKP:GetFriendsFrameWidth())
    end
    GuildFrameNotesText:SetWidth(FriendsFrame:GetWidth() - 20)
    self:FixToggleButton()
end
function BohemkaDKP:FixToggleButton()
    GuildFrameGuildListToggleButton:ClearAllPoints()
    local totalMembers, onlineMembers, _ = GetNumGuildMembers();
    local numGuildMembers = 0;
    local showOffline = GetGuildRosterShowOffline();
    if (showOffline) then
        numGuildMembers = totalMembers;
    else
        numGuildMembers = onlineMembers;
    end
    local diff = 0
    local noteWidth = 75
    local noteHeaderWidth = GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_NOTE
    local onlineButtonWidth = GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_ONLINE
    if numGuildMembers <= GUILDMEMBERS_TO_DISPLAY then
        diff = 25
        noteHeaderWidth = 90
        noteWidth = 85
        onlineButtonWidth = GUILD_FRAME_GUILD_STATUS_COLUMN_WIDTH_ONLINE_NO_SCROLL
    end
    WhoFrameColumn_SetWidth(GuildFrameGuildStatusColumnHeader5, noteHeaderWidth)
    for i=1, GUILDMEMBERS_TO_DISPLAY, 1 do
        local officerNoteButton = getglobal("GuildFrameGuildStatusButton"..i.."OfficerNote")
        officerNoteButton:SetWidth(noteWidth)
        local onlineButton = getglobal("GuildFrameGuildStatusButton"..i.."Online")
        onlineButton:SetWidth(onlineButtonWidth)
    end

    local padding = 0
    if self.isEditMode and BohemkaDKPConfig.showDKP then
        padding = -145
    end
    GuildFrameGuildListToggleButton:SetPoint("BOTTOMRIGHT", "GuildListScrollFrame", padding + diff, 0);
end
function BohemkaDKP:UpdateAuctionUIState()
    if self.currentItem then
        self:UpdateBidButtonState()
        if self:IsPlayerAuctionOwner() then
            self:ValidateBidderDKP()
        end
    end
end
function BohemkaDKP:UpdateUIGuildPermissions()
    if CanEditPublicNote() then
        DetailFrameDKPFrame.add:Show()
        DetailFrameDKPFrame.subtract:Show()
        GuildFrameDKPButton:Enable()
    else
        DetailFrameDKPFrame.add:Hide()
        DetailFrameDKPFrame.subtract:Hide()
        GuildFrameDKPButton:Disable()
    end
end
function BohemkaDKP:UpdateDetailFrame()
    local detailFrameHeight = GUILD_DETAIL_NORM_HEIGHT + 20
    local fullName, _, _, _, _, _, note, _, _ = GetGuildRosterInfo(GetGuildRosterSelection());
    if ( GetGuildRosterSelection() > 0 ) then
        GuildMemberDetailNoteLabel.dkp:SetText(self:NoteDKPToNumber(note))
        local professions = self:GetPlayerProfessions(fullName)
        if #professions > 0 then
            detailFrameHeight = GUILD_DETAIL_OFFICER_HEIGHT
        end
        self:RenderProfessions("DetailFrameProfFrame%dProf", professions, true)
    else
        GuildMemberDetailFrame:Hide()
    end
    GuildMemberDetailFrame:SetHeight(detailFrameHeight);
end
function BohemkaDKP:CreateAuctionFrame()
    local containerWidth = 210
    local container =  CreateFrame("Frame", nil, UIParent, BackdropTemplateMixin and "BackdropTemplate" or nil)
    local pos = BohemkaDKPConfig.position or {}
    container:SetPoint(pos.point or "CENTER", pos.x, pos.y)
    container:SetWidth(containerWidth)
    container:SetHeight(219)
    container:SetBackdrop(BACKDROP_DIALOG_32_32)
    container:SetMovable(true)
    container:EnableMouse(true)
    container:SetUserPlaced(true)
    container:RegisterForDrag("LeftButton")
    container:SetScript("OnDragStart", container.StartMoving)
    container:SetScript("OnDragStop", function()
        local point, _, _, xOfs, yOfs = container:GetPoint()
        BohemkaDKPConfig.position = {
            x = xOfs,
            y = yOfs,
            point = point
        }
        container:StopMovingOrSizing()
    end)
    container:Hide()
    self.frames.auction = container


    local f2 = CreateFrame("BUTTON", "AuctionDKPClose", container, "UIPanelCloseButton");
    f2:SetPoint("TOPRIGHT", container, "TOPRIGHT", -4, -4)

    local frameHeader = container:CreateTexture("$parentHeader", "OVERLAY")
    frameHeader:SetPoint("TOP", 0, 12)
    frameHeader:SetTexture(131080) -- "Interface\\DialogFrame\\UI-DialogBox-Header"
    frameHeader:SetSize(290, 64)

    local frameHeaderText = container:CreateFontString("$parentHeaderText", "OVERLAY", "GameFontNormal")
    frameHeaderText:SetPoint("TOP", frameHeader, 0, -14)
    frameHeaderText:SetText("Auction")

    container.paper = container:CreateTexture(nil, "ARTWORK")
    container.paper:SetPoint("TOPLEFT", 11, -11)
    container.paper:SetWidth(257)
    container.paper:SetHeight(138)
    container.paper:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-Reputation-DetailBackground")
    -- container.paper:SetColorTexture(0, 0, 0, 1)

    container.divider = container:CreateTexture(nil, "OVERLAY")
    container.divider:SetPoint("TOPLEFT", 9, -139)
    container.divider:SetWidth(256)
    container.divider:SetHeight(32)
    container.divider:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Divider")



    local a = CreateFrame("Frame", nil, container, BackdropTemplateMixin and "BackdropTemplate" or nil)
    a:SetSize(137, 21)
    a:SetPoint("TOP", 0, -25)
    a:SetBackdrop({
        bgFile   = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 12,
        insets = { left = 3, right = 3, top = 3, bottom = 3, },
    })
    a:SetBackdropColor(0, 0, 0, 0.7)
    a:SetBackdropBorderColor(0.2, 0.2, 0.2)
    a:Hide()

    container.statusBar = CreateFrame("StatusBar", nil, a)
    container.statusBar:SetPoint("TOPLEFT", 4, -4)
    container.statusBar:SetPoint("TOPRIGHT", -4, 6)
    container.statusBar:SetWidth(137)
    -- container.statusBar:SetFrameStrata("HIGH")
    container.statusBar:SetHeight(13)
    container.statusBar:SetMinMaxValues(0, BohemkaDKP.currentTime)
    container.statusBar:SetValue(BohemkaDKP.currentTime)
    container.statusBar:SetStatusBarTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
    container.statusBar.parent = a

    font = container.statusBar:CreateFontString(nil,"ARTWORK", "GameFontHighlightSmall")
    font:SetJustifyH("CENTER")
    font:SetPoint("CENTER")
    font:SetText("60")
    font:SetTextColor(1, 0.82, 0)

    container.item =  CreateFrame("BUTTON", "AuctionFrameItem", container, "LootButtonTemplate")
    container.item:SetPoint("TOPLEFT", a, "BOTTOMLEFT", -7, -5)
    container.item:SetHitRectInsets(0, -107, 0, 0)
    container.item:SetScript("OnClick", nil)
    container.item:SetScript("OnUpdate", nil)
    container.item:SetScript("OnEnter", function(self)
        if not BohemkaDKP.currentItem then
            return
        end
        GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
        itemName, itemLink = GetItemInfo(BohemkaDKP.currentItem.id)
        GameTooltip:SetHyperlink(itemLink)
        GameTooltip:Show();
    end)

    container.statusBar.font = font

    local price = container.item:CreateFontString(nil,"ARTWORK", "GameFontHighlightLarge")
    price:SetJustifyH("CENTER")
    price:SetPoint("TOPLEFT", container.item, "BOTTOMLEFT", 0, -13)
    price:SetText("Price:")
    price:SetTextColor(1, 0.82, 0)

    local priceValue = container.item:CreateFontString("AuctionItemPriceValue","ARTWORK", "GameFontHighlightLarge")
    priceValue:SetJustifyH("LEFT")
    priceValue:SetPoint("LEFT", price, "RIGHT", 5, 0)
    priceValue:SetText("100")
    priceValue:SetWidth(100)
    priceValue:SetTextColor(1, 0.82, 0)
    container.item.priceValue = priceValue

    local e = CreateFrame("EditBox", "BidValue", container, "InputBoxTemplate")
    e:SetWidth(70)
    e:SetHeight(33)
    e:SetPoint("BOTTOM", 2, 7)
    e:SetFontObject("GameFontHighlight")
    e:SetTextInsets(5,8,0,0)
    e:SetMultiLine(false)
    e:SetAutoFocus(false)
    e:SetNumeric(true)
    e:SetJustifyH("CENTER")
    e:SetScript( "OnEscapePressed", function( )
        e:ClearFocus()
    end )
    e:SetText("10")
    e:SetScript("OnEnterPressed", function(self)
        self:ClearFocus()
        BohemkaDKP:Bid(tonumber(self:GetText()))
    end)
    e:SetScript("OnChar", function(self)
        self.isChanged = true
    end)


    local btn = CreateFrame("Button", "BidButton", container, "UIPanelButtonTemplate")
    btn:SetPoint("BOTTOMRIGHT", container, -10, 10)
    btn:SetSize(56, 28)
    btn:SetText("Bid")
    btn:RegisterForClicks("AnyUp")
    btn:SetScript("OnClick", function()
        BohemkaDKP:Bid(e:GetNumber())
        e:ClearFocus()
        e.isChanged = false
    end)

    container.bid = btn

    local pass = CreateFrame("Button", "ButtonPass", container, "UIPanelButtonTemplate")
    pass:SetPoint("BOTTOMLEFT", 10, 10)
    pass:SetSize(56, 28)
    pass:SetText("Pass")
    pass:RegisterForClicks("AnyUp")
    pass:SetScript("OnClick", function()
        e:ClearFocus()
        BohemkaDKP:Pass()
    end)

    container.pass = pass

    local highestBidder = container.item:CreateFontString(nil,"ARTWORK", "GameFontHighlight")
    highestBidder:SetJustifyH("CENTER")
    highestBidder:SetPoint("TOPLEFT", price, "BOTTOMLEFT", 1, -3)
    highestBidder:SetText("Highest bid:")
    highestBidder:SetTextColor(1, 0.82, 0)
    highestBidder:Hide()
    container.highestBidder = highestBidder

    local currentDKP = container:CreateFontString(nil,"ARTWORK", "GameFontNormal")
    currentDKP:SetJustifyH("RIGHT")
    currentDKP:SetPoint("BOTTOMRIGHT", btn, "TOPRIGHT", -13, 4)
    currentDKP:SetText("")

    local arrow = container:CreateTexture("$parentHeader", "ARTWORK")
    arrow:SetPoint("BOTTOM", 0, 44)
    arrow:SetTexture("Interface\\Glues\\Common\\Glue-RightArrow-Button-Up") -- "Interface\\DialogFrame\\UI-DialogBox-Header"
    arrow:SetSize(24, 24)

    local currentDKPValue = container:CreateFontString(nil,"ARTWORK", "GameFontHighlight")
    currentDKPValue:SetJustifyH("LEFT")
    currentDKPValue:SetPoint("LEFT", arrow, "RIGHT", 5, 0)
    currentDKPValue:SetText("0")
    container.currentDKPValue = currentDKPValue

    local b = container:CreateFontString(nil,"ARTWORK", "GameFontNormal")
    b:SetJustifyH("CENTER")
    b:SetPoint("RIGHT", arrow, "LEFT", -5, 0)
    b:SetText()
    container.totalDKPValue = b

    local divider2 = container:CreateTexture(nil, "OVERLAY")
    divider2:SetPoint("TOPLEFT", 9, -169)
    divider2:SetWidth(256)
    divider2:SetHeight(32)
    divider2:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Divider")

    local marble = container:CreateTexture(nil, "BACKGROUND")
    marble:SetPoint("TOPLEFT", container.divider, "TOPLEFT", 0, -5)
    marble:SetWidth(containerWidth - 20)
    marble:SetHeight(70)
    marble:SetTexture("Interface\\FrameGeneral\\UI-Background-Marble")


    local lootMasterFrame = CreateFrame("Frame", "LootMasterFrame", container, BackdropTemplateMixin and "BackdropTemplate" or nil)
    lootMasterFrame:SetPoint("TOPLEFT", container, "TOPRIGHT", -12, 0)
    lootMasterFrame:SetWidth(170)
    lootMasterFrame:SetHeight(219)
    lootMasterFrame:SetBackdrop(BACKDROP_DIALOG_32_32)
    lootMasterFrame:Hide()

    container.lootMasterFrame = lootMasterFrame

    local bg = lootMasterFrame:CreateTexture(nil, "ARTWORK")
    bg:SetPoint("TOPLEFT", 12, -12)
    bg:SetPoint("BOTTOMRIGHT", -12, 12)
    bg:SetTexture("Interface\\FrameGeneral\\UI-Background-Rock")

    local f = CreateFrame("BUTTON", "BidderNameHeader1", lootMasterFrame, "GuildFrameColumnHeaderTemplate");
    f:SetPoint("TOPLEFT", 11, -12)
    f:SetText("Name")
    WhoFrameColumn_SetWidth(f, 105)

    f2 = CreateFrame("BUTTON", "BidderNameHeader2", lootMasterFrame, "GuildFrameColumnHeaderTemplate");
    f2:SetPoint("LEFT", f, "RIGHT", 0, 0)
    f2:SetText("DKP")
    WhoFrameColumn_SetWidth(f2, 43)

    local lootMasterFrameBg = CreateFrame("Frame", "LootMasterFrame", lootMasterFrame, "InsetFrameTemplate")
    lootMasterFrameBg:SetPoint("TOPLEFT", 10, -33)
    lootMasterFrameBg:SetPoint("BOTTOMRIGHT", -10, 10)

    local award = CreateFrame("Button", "ButtonLMAward", lootMasterFrame, "UIPanelButtonTemplate")
    award:SetPoint("BOTTOMRIGHT", -15, 16)
    award:SetSize(56, 28)
    award:SetText("Award")
    award:Disable()
    award:RegisterForClicks("AnyUp")
    award:SetScript("OnClick", function()
        BohemkaDKP:EndAuction()
    end)
    lootMasterFrame.award = award

    local prevFrame
    for i = 1, BIDDER_TABLE_SIZE do
        local frameName = "LootMasterFrameBidder"..i
        local bidder = CreateFrame("Button", frameName, lootMasterFrame)
        bidder:SetNormalTexture("Interface\\GuildFrame\\GuildFrame")
        bidder:GetNormalTexture():SetTexCoord(0.36230469, 0.38183594, 0.95898438, 0.99804688)
        bidder:SetHighlightTexture("Interface\\FriendsFrame\\UI-FriendsFrame-HighlightBar")
        bidder.Reset = function(self)
            self:Hide()
            self:UnlockHighlight()
            self.selected = false
        end
        bidder:SetSize(142, 18)
        bidder:SetScript("OnClick", function(self)
            for j = 1, BIDDER_TABLE_SIZE do
                local frame = _G["LootMasterFrameBidder"..j]
                if frame ~= bidder then
                    frame:UnlockHighlight()
                    frame.selected = false
                end
            end
            if not self.selected then
                self:LockHighlight()
                self.selected = true
            else
                self:UnlockHighlight()
                self.selected = false
            end
            BohemkaDKP:UpdateWinner()
        end)
        local bidderName = bidder:CreateFontString(frameName.."Name","ARTWORK", "GameFontNormalSmall")
        bidderName:SetJustifyH("LEFT")
        bidderName:SetPoint("LEFT", 5, 0)
        bidderName:SetText("")
        local bidderValue = bidder:CreateFontString(frameName.."Value","ARTWORK", "GameFontNormalSmall")
        bidderValue:SetJustifyH("LEFT")
        bidderValue:SetPoint("RIGHT", -5, 0)
        bidderValue:SetText()
        if prevFrame then
            bidder:SetPoint("TOP", prevFrame, "BOTTOM", 0, 0)
        else
            bidder:SetPoint("TOP", lootMasterFrameBg, "TOP", 0, -4)
        end
        prevFrame = bidder
        bidder.name = bidderName
        bidder.value = bidderValue
        bidder:Hide()
    end

    local divider3 = lootMasterFrameBg:CreateTexture(nil, "OVERLAY")
    divider3:SetPoint("TOPLEFT", prevFrame, "BOTTOMLEFT", -3, 4)
    divider3:SetWidth(200)
    divider3:SetHeight(32)
    divider3:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Divider")

    local cancel = CreateFrame("Button", "ButtonLMCancel", lootMasterFrame, "UIPanelButtonTemplate")
    cancel:SetPoint("BOTTOMLEFT", 15, 16)
    cancel:SetSize(56, 28)
    cancel:SetText("Cancel")
    cancel:RegisterForClicks("AnyUp")
    cancel:SetScript("OnClick", function()
        if BohemkaDKP.countdownActive then
            BohemkaDKP:CancelAuctionCountdown()
            return
        end
        BohemkaDKP.currentItem.winner = nil
        BohemkaDKP:EndAuction()

    end)




    --local btn = CreateFrame("Button", nil, UIParent, "UIPanelButtonTemplate")
    --btn:SetPoint("CENTER")
    --btn:SetSize(56, 28)
    --btn:SetText("Transfer")
    --btn:RegisterForClicks("AnyUp")
    --btn:SetScript("OnClick", function()
    --    local totalMembers, onlineMembers, onlineAndMobileMembers = GetNumGuildMembers();
    --    local tmp = {}
    --    for i,v in ipairs({strsplit("\n", BohemkaDKP.cDKP)}) do
    --        local name, class, dkp = strsplit(",", v)
    --        tmp[name] = tonumber(dkp)
    --    end
    --    for i = 1, totalMembers do
    --        fullName, rank, rankIndex, level, class, zone, note, officernote, online, isAway = GetGuildRosterInfo(i);
    --        local importedDKP = tmp[strsplit("-", fullName)]
    --        -- print("IMPORTING DKP", fullName, importedDKP, string.format("%05d", importedDKP or ""))
    --        if importedDKP then
    --            BohemkaDKP:SaveDKP(i, importedDKP)
    --        end
    --    end
    --end)
end
function BohemkaDKP:GetTimerColor(value, maxValue)
    local prc = (100 / maxValue) * value
    for _, c in pairs(BohemkaDKPConfig.timerColors) do
        if prc >= c[1] then
            return c[2]
        end
    end
end
function BohemkaDKP:UpdateBidderTable()
    if not self.bidHistory then
        return
    end
    self.sortedHistory = {}
    for name, bid in pairs(self.bidHistory) do
        if bid ~= nil then
            table.insert(self.sortedHistory, {name=name, bid=bid})
        end
    end
    table.sort(self.sortedHistory, function(a,b) return a.bid > b.bid end)
    for i = 1, BIDDER_TABLE_SIZE do
        local btn = _G["LootMasterFrameBidder"..i]
        local bidder = self.sortedHistory[i]
        if not bidder then
            btn:Reset()
        else
            local name = self:AddClassColorToName(bidder.name)
            btn.name:SetText(strsplit("-", name))
            btn.value:SetText(bidder.bid)
            btn:Show()
        end
    end
end
function BohemkaDKP:RefreshTotalDKP()
    local currentDKP = self:GetCurrentDKP()
    self.frames.auction.totalDKPValue:SetText(currentDKP)
    if self.currentItem and self.currentItem.price then
        BohemkaDKP:SetCurrentDKPValue(currentDKP - self.currentItem.price)
    end

end
function BohemkaDKP:SetCurrentDKPValue(value)
    if value <= 0 then
        value = BohemkaDKP:colorize(value, BohemkaDKP.COLOR.RED)
    end
    self.frames.auction.currentDKPValue:SetText(value)
end
function BohemkaDKP:AddStaticPopups()
    StaticPopupDialogs["SET_GUILDPLAYERDKP"] = {
        text = "Set DKP",
        button1 = ACCEPT,
        button2 = CANCEL,
        hasEditBox = 1,
        maxLetters = 31,
        wide = false,
        editBoxWidth = 50,
        OnAccept = function(self)
            BohemkaDKP:SaveDKP(GetGuildRosterSelection(), tonumber(self.editBox:GetText()), "GUILD")
        end,
        OnShow = function(self)
            --Sets the text to the 7th return from GetGuildRosterInfo(GetGuildRosterSelection());
            self.editBox:SetText(BohemkaDKP:NoteDKPToNumber(select(7, GetGuildRosterInfo(GetGuildRosterSelection()))));
            self.editBox:SetFocus();
        end,
        OnHide = function(self)
            ChatEdit_FocusActiveWindow();
            self.editBox:SetText("");
        end,
        EditBoxOnEnterPressed = function(self)
            local parent = self:GetParent();
            BohemkaDKP:SaveDKP(GetGuildRosterSelection(), tonumber(parent.editBox:GetText()), "GUILD")
            parent:Hide();
        end,
        EditBoxOnEscapePressed = function(self)
            self:GetParent():Hide();
        end,
        timeout = 0,
        exclusive = 1,
        whileDead = 1,
        hideOnEscape = 1
    };
    StaticPopupDialogs["SUBTRACT_GUILDPLAYERDKP"] = {
        text = "Subtract DKP",
        button1 = ACCEPT,
        button2 = CANCEL,
        hasEditBox = 1,
        maxLetters = 31,
        wide = false,
        editBoxWidth = 50,
        OnAccept = function(self)
            local currentValue = BohemkaDKP:NoteDKPToNumber(select(7, GetGuildRosterInfo(GetGuildRosterSelection())))
            BohemkaDKP:SaveDKP(GetGuildRosterSelection(), currentValue - self.editBox:GetNumber(), "GUILD")
        end,
        OnShow = function(self)
            self.editBox:SetText("");
            self.editBox:SetFocus();
        end,
        OnHide = function(self)
            ChatEdit_FocusActiveWindow();
            self.editBox:SetText("");
        end,
        EditBoxOnEnterPressed = function(self)
            local parent = self:GetParent();
            local currentValue = BohemkaDKP:NoteDKPToNumber(select(7, GetGuildRosterInfo(GetGuildRosterSelection())))
            BohemkaDKP:SaveDKP(GetGuildRosterSelection(), currentValue - parent.editBox:GetNumber(), "GUILD")
            parent:Hide();
        end,
        EditBoxOnEscapePressed = function(self)
            self:GetParent():Hide();
        end,
        timeout = 0,
        exclusive = 1,
        whileDead = 1,
        hideOnEscape = 1
    };
    StaticPopupDialogs["ADD_GUILDPLAYERDKP"] = {
        text = "Add DKP",
        button1 = ACCEPT,
        button2 = CANCEL,
        hasEditBox = 1,
        maxLetters = 31,
        wide = false,
        editBoxWidth = 50,
        OnAccept = function(self)
            local currentValue = BohemkaDKP:NoteDKPToNumber(select(7, GetGuildRosterInfo(GetGuildRosterSelection())))
            BohemkaDKP:SaveDKP(GetGuildRosterSelection(), currentValue + self.editBox:GetNumber(), "GUILD")
        end,
        OnShow = function(self)
            self.editBox:SetText("");
            self.editBox:SetFocus();
        end,
        OnHide = function(self)
            ChatEdit_FocusActiveWindow();
            self.editBox:SetText("");
        end,
        EditBoxOnEnterPressed = function(self)
            local parent = self:GetParent();
            local currentValue = BohemkaDKP:NoteDKPToNumber(select(7, GetGuildRosterInfo(GetGuildRosterSelection())))
            BohemkaDKP:SaveDKP(GetGuildRosterSelection(), currentValue + parent.editBox:GetNumber(), "GUILD")
            parent:Hide();
        end,
        EditBoxOnEscapePressed = function(self)
            self:GetParent():Hide();
        end,
        timeout = 0,
        exclusive = 1,
        whileDead = 1,
        hideOnEscape = 1
    };

    StaticPopupDialogs["SUBTRACT_GUILDPLAYERDKP_MANY"] = {
        text = "Subtract DKP",
        button1 = ACCEPT,
        button2 = CANCEL,
        hasEditBox = 1,
        maxLetters = 31,
        wide = false,
        editBoxWidth = 50,
        OnAccept = function(self)
            BohemkaDKP:SubtractDKPSelected(self.editBox:GetNumber())
        end,
        OnShow = function(self)
            self.editBox:SetText("");
            self.editBox:SetFocus();
        end,
        OnHide = function(self)
            ChatEdit_FocusActiveWindow();
            self.editBox:SetText("");
        end,
        EditBoxOnEnterPressed = function(self)
            local parent = self:GetParent()
            BohemkaDKP:SubtractDKPSelected(parent.editBox:GetNumber())
            parent:Hide();
        end,
        EditBoxOnEscapePressed = function(self)
            self:GetParent():Hide();
        end,
        timeout = 0,
        exclusive = 1,
        whileDead = 1,
        hideOnEscape = 1
    };

    StaticPopupDialogs["ADD_GUILDPLAYERDKP_MANY"] = {
        text = "Add DKP",
        button1 = ACCEPT,
        button2 = CANCEL,
        hasEditBox = 1,
        maxLetters = 31,
        wide = false,
        editBoxWidth = 50,
        OnAccept = function(self)
            BohemkaDKP:AddDKPSelected(self.editBox:GetNumber())
        end,
        OnShow = function(self)
            self.editBox:SetText("");
            self.editBox:SetFocus();
        end,
        OnHide = function(self)
            ChatEdit_FocusActiveWindow();
            self.editBox:SetText("");
        end,
        EditBoxOnEnterPressed = function(self)
            local parent = self:GetParent()
            BohemkaDKP:AddDKPSelected(parent.editBox:GetNumber())
            parent:Hide();
        end,
        EditBoxOnEscapePressed = function(self)
            self:GetParent():Hide();
        end,
        timeout = 0,
        exclusive = 1,
        whileDead = 1,
        hideOnEscape = 1
    };
    StaticPopupDialogs["AWARD_GUILDPLAYERDKP_RAID"] = {
        text = "Award DKP",
        button1 = ACCEPT,
        button2 = CANCEL,
        hasEditBox = 1,
        maxLetters = 31,
        wide = false,
        editBoxWidth = 50,
        OnAccept = function(self)
            BohemkaDKP:AwardDKPRaid(self.editBox:GetNumber())
        end,
        OnShow = function(self)
            self.editBox:SetText("");
            self.editBox:SetFocus();
        end,
        OnHide = function(self)
            ChatEdit_FocusActiveWindow();
            self.editBox:SetText("");
        end,
        EditBoxOnEnterPressed = function(self)
            local parent = self:GetParent()
            BohemkaDKP:AwardDKPRaid(parent.editBox:GetNumber())
            parent:Hide();
        end,
        EditBoxOnEscapePressed = function(self)
            self:GetParent():Hide();
        end,
        timeout = 0,
        exclusive = 1,
        whileDead = 1,
        hideOnEscape = 1
    };
end
function BohemkaDKP:UpdateBidButtonState()
    if not self.currentItem then
        return
    end
    if self.passed then
        self:EnableBidding(false)
    end
    local playerName = self:GetPlayerName(true)
    local hasEnoughDKP = self.currentItem.price <= self:GetCurrentDKP(playerName)
    if self.bidInfo.name ~= playerName then
        self:EnableBidding(hasEnoughDKP and not self.currentItem.allIn)
    else
        self:EnableBidding(false)
    end
end
function BohemkaDKP:UpdateWinner()
    local isSelected = 0
    for i = 1, BIDDER_TABLE_SIZE do
        local frame = _G["LootMasterFrameBidder"..i]
        if frame.selected then
            isSelected = i
            break
        end
    end
    if isSelected > 0 then
        self.frames.auction.lootMasterFrame.award:Enable()
        self.currentItem.winner = BohemkaDKP.sortedHistory[isSelected]
    else
        self.frames.auction.lootMasterFrame.award:Disable()
        self.currentItem.winner = nil
    end
end
function BohemkaDKP:AddConfigEditBox(parent, relativeTo, frameName, name, value, suffix)
    local font = parent:CreateFontString("$parentText"..frameName,"ARTWORK", "GameFontNormal")
    font:SetJustifyH("LEFT")
    font:SetSize(140, 14)
    font:SetPoint(unpack(relativeTo))
    font:SetText(name)

    local editbox = CreateFrame("EditBox", "$parentEditBox"..frameName, parent, "InputBoxTemplate")
    editbox:SetAutoFocus(false)
    editbox:SetNumber(BohemkaDKPConfig[value])
    editbox:SetSize(50,30)
    editbox:SetPoint("LEFT", font, "RIGHT", 0, 0)
    editbox:SetNumeric(true)
    editbox:SetMultiLine(false)
    editbox:SetFontObject("GameFontHighlight")
    editbox:SetTextInsets(5,8,0,0)
    editbox:SetJustifyH("RIGHT")
    editbox:SetScript( "OnEscapePressed", function( self )
        self:ClearFocus()
    end )

    editbox:SetScript( "OnEnterPressed", function( self )
        self:ClearFocus()
    end )

    local font2 = parent:CreateFontString("$parentText"..frameName.."Suffix","ARTWORK", "GameFontNormal")
    font2:SetJustifyH("LEFT")
    font2:SetSize(140, 14)
    font2:SetPoint("LEFT", editbox, "RIGHT", 5, 0)
    font2:SetText(suffix or "")

    return font, editbox
end
function BohemkaDKP:CreateInterfaceConfig()
    local f = CreateFrame("Frame", "BohemkaDKPInterfaceOptionsPanel", UIParent,  BackdropTemplateMixin and "BackdropTemplate" or nil)
    f:SetPoint("CENTER")
    f:SetSize(512, 512)
    f.name = AddonName
    f:Hide()

    local debug = CreateFrame("CheckButton", "$parentDebug", f, "UICheckButtonTemplate");
    debug:SetSize(22,22)
    debug:SetPoint("TOPRIGHT", f, "TOPRIGHT", -30, -26)
    debug:SetChecked(BohemkaDKPConfig.debug)



    local font = debug:CreateFontString("$parentTextItemPrice","ARTWORK", "GameFontNormal")
    font:SetJustifyH("LEFT")
    font:SetSize(50, 14)
    font:SetPoint("RIGHT", debug, "LEFT", 0, 0)
    font:SetText("Debug")

    local importFrame = CreateFrame("Frame", "BohemkaDKPImportFrame", UIParent,  BackdropTemplateMixin and "BackdropTemplate" or nil)
    importFrame:SetPoint("CENTER")
    importFrame:SetSize(512, 512)
    importFrame:SetBackdrop(BACKDROP_DIALOG_32_32)
    importFrame:Hide()

    local f2 = CreateFrame("BUTTON", "$parentClose", importFrame, "UIPanelCloseButton");
    f2:SetPoint("TOPRIGHT", importFrame, "TOPRIGHT", -4, -4)

    local editbox = CreateFrame("EditBox", "$parentEditBox", importFrame)
    editbox:SetAllPoints(importFrame)
    editbox:SetWidth(importFrame:GetWidth() - 30)
    editbox:SetHeight(importFrame:GetHeight())
    editbox:SetFontObject("GameFontHighlight")
    editbox:SetAutoFocus(true)
    editbox:SetMultiLine(true)
    editbox:SetTextInsets(8,4,4,4)
    editbox:SetJustifyH("LEFT")
    editbox:SetScript( "OnEscapePressed", function( self )
        self:ClearFocus()
        importFrame:Hide()
    end )

    local Scroll = CreateFrame('ScrollFrame', '$parentEditBoxScroll', importFrame, 'UIPanelScrollFrameTemplate')
    Scroll:SetPoint('TOPLEFT', importFrame, 'TOPLEFT', 10, -30)
    Scroll:SetPoint('BOTTOMRIGHT', importFrame, 'BOTTOMRIGHT', -36, 42)
    Scroll:SetScrollChild(editbox)

    local import = CreateFrame("BUTTON", "$parentImport", importFrame, "UIPanelButtonTemplate");
    import:SetPoint("BOTTOM", 0, 15)
    import:SetWidth(120)
    import:SetText("Import")
    import:SetScript("OnClick", function()
        local totalMembers, _, _ = GetNumGuildMembers();
        local tmp = {}
        for _,v in ipairs({strsplit("\n", editbox:GetText())}) do
            local name, _, dkp = strsplit(",", v)
            dkp = tonumber(dkp)
            if dkp then
                tmp[name] = dkp
            end
        end
        if #tmp > 0 then
            for i = 1, totalMembers do
                fullName, rank, rankIndex, level, class, zone, note, officernote, online, isAway = GetGuildRosterInfo(i);
                local importedDKP = tmp[strsplit("-", fullName)]
                -- print("IMPORTING DKP", fullName, importedDKP, string.format("%05d", importedDKP or ""))
                if importedDKP then
                    BohemkaDKP:SaveDKP(i, importedDKP)
                end
            end
        end
        importFrame:Hide()
    end)


    import = CreateFrame("BUTTON", "$parentImport", f, "UIPanelButtonTemplate");
    import:SetPoint("TOPLEFT", font, "BOTTOMLEFT", -50, -5)
    import:SetWidth(120)
    import:SetText("Import data")
    import:SetScript("OnClick", function()
        CloseMenus();
        CloseAllWindows()
        HideUIPanel(GameMenuFrame);
        importFrame:Show()
    end)





    local title, _ = BohemkaDKP:AddConfigEditBox(f, {"TOPLEFT", f, "TOPLEFT", 30, -30}, "MinimalBid", "Minimal Bid", "minBid", "DKP")
    title, _ = BohemkaDKP:AddConfigEditBox(f, {"TOPLEFT", title, "BOTTOMLEFT", 0, -10}, "MinItemPrice", "Minimal Item Price", "minItemPrice", "DKP")
    title, _ = BohemkaDKP:AddConfigEditBox(f, {"TOPLEFT", title, "BOTTOMLEFT", 0, -10}, "AuctionCountdown", "Auction Countdown", "timerMax", "second(s)")
    title, _ = BohemkaDKP:AddConfigEditBox(f, {"TOPLEFT", title, "BOTTOMLEFT", 0, -10}, "StartingDKP", "Initial DKP", "startingDKP")
    title, _ = BohemkaDKP:AddConfigEditBox(f, {"TOPLEFT", title, "BOTTOMLEFT", 0, -10}, "BidCooldown", "Bid Cooldown", "bidCooldown", "second(s)")


    local l = f:CreateLine()
    l:SetColorTexture(0.3,0.3,0.3)
    l:SetStartPoint("TOPLEFT", f, 30, -160)
    l:SetEndPoint("TOPRIGHT", f, -30, -160)
    l:SetThickness(1)

    font = f:CreateFontString("$parentTextItemPrice","ARTWORK", "GameFontNormal")
    font:SetJustifyH("CENTER")
    font:SetSize(256, 14)
    font:SetPoint("TOPLEFT", l, "BOTTOMLEFT", 0, -10)
    font:SetText("Custom Minimal Item Price")

    local editBoxHeight = 315
    editboxBg = CreateFrame("Frame", "$parentEditBox", f, "TooltipBackdropTemplate")
    editboxBg:SetSize(font:GetWidth(), editBoxHeight)
    editboxBg:SetPoint("TOP", font, "BOTTOM", 0, -5)

    local itemPriceConfig = self:TableToConfigText(BohemkaDKPConfig.itemPrices)
    editbox = CreateFrame("EditBox", "$parentItemPrice", editboxBg)
    editbox:SetAllPoints(editboxBg)
    editbox:SetWidth(editboxBg:GetWidth() - 30)
    editbox:SetHeight(editboxBg:GetHeight())
    editbox:SetFontObject("GameFontHighlight")
    editbox:SetAutoFocus(false)
    editbox:SetMultiLine(true)
    editbox:SetTextInsets(8,8,8,8)
    editbox:SetText(itemPriceConfig)
    editbox:SetJustifyH("LEFT")
    editbox:SetScript( "OnEscapePressed", function( self )
        self:ClearFocus()
    end )

    Scroll = CreateFrame('ScrollFrame', 'nChatCopyScroll', f, 'UIPanelScrollFrameTemplate')
    Scroll:SetPoint('TOPLEFT', editboxBg, 'TOPLEFT', 8, -4)
    Scroll:SetPoint('BOTTOMRIGHT', editboxBg, 'BOTTOMRIGHT', -26, 3)
    Scroll:SetScrollChild(editbox)

    font = f:CreateFontString("$parentTextItemPrice","ARTWORK", "GameFontNormalSmall")
    font:SetJustifyH("LEFT")
    font:SetWidth(editbox:GetWidth())
    font:SetPoint("TOPLEFT", editboxBg, "BOTTOMLEFT", 10, -3)
    font:SetText("Example:")

    local font2 = f:CreateFontString("$parentTextItemPrice","ARTWORK", "GameFontHighlightSmall")
    font2:SetJustifyH("LEFT")
    font2:SetSize(editbox:GetWidth(), 40)
    font2:SetPoint("TOPLEFT", font, "BOTTOMLEFT", 0, 5)
    font2:SetText("Item Name=10\nItem Name2=30")

    font = f:CreateFontString("$parentTextItemPrice","ARTWORK", "GameFontNormal")
    font:SetJustifyH("CENTER")
    font:SetSize(256, 14)
    font:SetPoint("TOPRIGHT", l, "BOTTOMRIGHT", 0, -10)
    font:SetText("Boss Reward")


    local editboxBg = CreateFrame("Frame", "$parentEditBox", f, "TooltipBackdropTemplate")
    editboxBg:SetSize(font:GetWidth(), editBoxHeight)
    editboxBg:SetPoint("TOP", font, "BOTTOM", 0, -5)

    editbox = CreateFrame("EditBox", "$parentBossRewards", editboxBg)
    editbox:SetAllPoints(editboxBg)
    editbox:SetWidth(editboxBg:GetWidth() - 30)
    editbox:SetHeight(editboxBg:GetHeight())
    editbox:SetFontObject("GameFontHighlight")
    editbox:SetAutoFocus(false)
    editbox:SetMultiLine(true)
    editbox:SetText(self:TableToConfigText(BohemkaDKPConfig.bossRewards))
    editbox:SetTextInsets(8,8,8,8)
    editbox:SetJustifyH("LEFT")
    editbox:SetScript( "OnEscapePressed", function( self )
        self:ClearFocus()
    end )
    editbox:SetScript( "OnEscapePressed", function( self )
        self:ClearFocus()
    end )



    Scroll = CreateFrame('ScrollFrame', 'nChatCopyScroll', f, 'UIPanelScrollFrameTemplate')
    Scroll:SetPoint('TOPLEFT', editboxBg, 'TOPLEFT', 8, -4)
    Scroll:SetPoint('BOTTOMRIGHT', editboxBg, 'BOTTOMRIGHT', -26, 3)
    Scroll:SetScrollChild(editbox)

    font = f:CreateFontString("$parentTextItemPrice","ARTWORK", "GameFontNormalSmall")
    font:SetJustifyH("LEFT")
    font:SetWidth(editboxBg:GetWidth())
    font:SetPoint("TOPLEFT", editboxBg, "BOTTOMLEFT", 10, -3)
    font:SetText("Example:")

    font2 = f:CreateFontString("$parentTextItemPrice","ARTWORK", "GameFontHighlightSmall")
    font2:SetJustifyH("LEFT")
    font2:SetSize(editbox:GetWidth(), 40)
    font2:SetPoint("TOPLEFT", font, "BOTTOMLEFT", 0, 5)
    font2:SetText("Boss 1=10\nBoss 2=30")

    f.okay = function()
        BohemkaDKPConfig.itemPrices = BohemkaDKP:ConfigTextToTable(BohemkaDKPInterfaceOptionsPanelEditBoxItemPrice:GetText())
        BohemkaDKPConfig.bossRewards = BohemkaDKP:ConfigTextToTable(BohemkaDKPInterfaceOptionsPanelEditBoxBossRewards:GetText())
        BohemkaDKPConfig.minBid = BohemkaDKPInterfaceOptionsPanelEditBoxMinimalBid:GetNumber()
        BohemkaDKPConfig.auctionCountdown= BohemkaDKPInterfaceOptionsPanelEditBoxAuctionCountdown:GetNumber()
        BohemkaDKPConfig.startingDKP = BohemkaDKPInterfaceOptionsPanelEditBoxStartingDKP:GetNumber()
        BohemkaDKPConfig.bidCooldown = BohemkaDKPInterfaceOptionsPanelEditBoxBidCooldown:GetNumber()
        BohemkaDKPConfig.debug = BohemkaDKPInterfaceOptionsPanelDebug:GetChecked()
    end

    f.cancel = function()
        BohemkaDKPInterfaceOptionsPanelEditBoxBossRewards:SetText(BohemkaDKP:TableToConfigText(BohemkaDKPConfig.bossRewards))
        BohemkaDKPInterfaceOptionsPanelEditBoxItemPrice:SetText(BohemkaDKP:TableToConfigText(BohemkaDKPConfig.itemPrices))
        BohemkaDKPInterfaceOptionsPanelEditBoxMinimalBid:SetNumber(BohemkaDKPConfig.minBid)
        BohemkaDKPInterfaceOptionsPanelEditBoxAuctionCountdown:SetNumber(BohemkaDKPConfig.auctionCountdown)
        BohemkaDKPInterfaceOptionsPanelEditBoxStartingDKP:SetNumber(BohemkaDKPConfig.startingDKP)
        BohemkaDKPInterfaceOptionsPanelEditBoxBidCooldown:SetNumber(BohemkaDKPConfig.bidCooldown)
        BohemkaDKPInterfaceOptionsPanelDebug:SetChecked(BohemkaDKPConfig.debug)

    end

    InterfaceOptions_AddCategory(f)
end
function BohemkaDKP:TableToConfigText(t)
    local str = {}
    for k, v in pairs(t) do
        table.insert(str, k.."="..v)
    end
    return table.concat(str, "\n")
end
function BohemkaDKP:ConfigTextToTable(txt)
    local t = {}
    for _, v in ipairs({strsplit("\n", txt)}) do
        local k, v2 = strsplit("=", v)
        t[k] = tonumber(v2) or v2
    end
    return t
end
function BohemkaDKP:RenderProfessions(frameName, professions, showSkill)
    for i = 1, PROFESSION_AMOUNT do
        local detailFrame = _G[format(frameName, i)]
        if professions[i] then
            detailFrame.parent.tooltip = professions[i].name
            if showSkill then
                detailFrame.parent.font:SetText(professions[i].rank)
            end
            detailFrame:SetTexture(professions[i].icon)
            detailFrame.parent:Show()
        else
            detailFrame.parent.tooltip = nil
            detailFrame.parent.font:SetText("")
            detailFrame:SetTexture(nil)
            detailFrame.parent:Hide()
        end
    end
end
function BohemkaDKP:GetFriendsFrameWidth()
    local width = FRIENDS_FRAME_WIDTH
    if not BohemkaDKPConfig.showProfessions then
        width = width - GUILD_FRAME_COLUMN_WIDTH_PROFESSIONS
    end
    if not BohemkaDKPConfig.showDKP then
        width = width - GUILD_FRAME_COLUMN_WIDTH_DKP
    end
    return width
end
